#分块,二分#zoj 2112 Dynamic Rankings

2024-02-11 05:58

本文主要是介绍#分块,二分#zoj 2112 Dynamic Rankings,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目

支持修改的区间动态第k小


分析

树状数组套主席树(主席树不支持单点修改)太麻烦了,所以就用一种虽然时间略长但是比较简短的代码,当然运用到大段维护,小段朴素的方法,具体就是二分答案,其实理解上去还是比较简单的


代码

#include <cstdio>
#include <cmath>
#include <algorithm>
#define rr register
#define L(x) ((x-1)*bk+1)
#define R(x) (x*bk>n?n:x*bk)
#define max(a,b) ((a>b)?a:b)
int n,a[50001],b[50001],pos[50001];
inline int in(){//逐字符输入rr int ans=0; rr char c=getchar();while (c<48||c>57) c=getchar();while (c>47&&c<58) ans=ans*10+c-48,c=getchar();return ans;
}
inline void resort(int x,int bk){//分块的思想(大段维护),所以要排序rr int l=L(x),r=R(x);for (rr int i=l;i<=r;++i) b[i]=a[i];std::sort(b+l,b+1+r);
}
inline void print(int ans){//逐字符输出if (ans>9) print(ans/10);putchar(ans%10+48);
}
inline int answ(int l,int r,int v,int bk){rr int ans=0;if (pos[l]==pos[r]){//小段朴素for (rr int i=l;i<=r;++i) ans+=a[i]<=v;}else{for (rr int i=l;i<=R(pos[l]);++i) ans+=a[i]<=v;for (rr int i=pos[l]+1;i<pos[r];++i) ans+=std::upper_bound(b+L(i),b+1+R(i),v)-b-L(i);//大段维护for (rr int i=L(pos[r]);i<=r;++i) ans+=a[i]<=v;}return ans;
}
int main(){rr int t=in();while (t--){n=in(); rr int m=in(); rr int block=sqrt(n);rr int k=n/block,mx=0; if (n%block) k++;for (rr int i=1;i<=n;++i) a[i]=in(),mx=max(a[i],mx);//剪枝(不必要的就不要)for (rr int i=1;i<=n;++i) pos[i]=(i-1)/block+1;for (rr int i=1;i<=k;++i) resort(i,block);//初始分块while (m--){rr char c=getchar(); while (c!='Q'&&c!='C') c=getchar();  rr int x=in();if (c=='C') a[x]=in(),mx=max(a[x],mx),resort(pos[x],block);//修改else{rr int y=in(),k=in(); rr int l=1,r=mx;//二分答案while (l<r){rr int mid=(l+r)>>1;if (answ(x,y,mid,block)>=k) r=mid; else l=mid+1;}print(l); putchar('\n');}}}return 0;
}

这篇关于#分块,二分#zoj 2112 Dynamic Rankings的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/698990

相关文章

hdu2241(二分+合并数组)

题意:判断是否存在a+b+c = x,a,b,c分别属于集合A,B,C 如果用暴力会超时,所以这里用到了数组合并,将b,c数组合并成d,d数组存的是b,c数组元素的和,然后对d数组进行二分就可以了 代码如下(附注释): #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<que

hdu2289(简单二分)

虽说是简单二分,但是我还是wa死了  题意:已知圆台的体积,求高度 首先要知道圆台体积怎么求:设上下底的半径分别为r1,r2,高为h,V = PI*(r1*r1+r1*r2+r2*r2)*h/3 然后以h进行二分 代码如下: #include<iostream>#include<algorithm>#include<cstring>#include<stack>#includ

poj 2976 分数规划二分贪心(部分对总体的贡献度) poj 3111

poj 2976: 题意: 在n场考试中,每场考试共有b题,答对的题目有a题。 允许去掉k场考试,求能达到的最高正确率是多少。 解析: 假设已知准确率为x,则每场考试对于准确率的贡献值为: a - b * x,将贡献值大的排序排在前面舍弃掉后k个。 然后二分x就行了。 代码: #include <iostream>#include <cstdio>#incl

poj 3104 二分答案

题意: n件湿度为num的衣服,每秒钟自己可以蒸发掉1个湿度。 然而如果使用了暖炉,每秒可以烧掉k个湿度,但不计算蒸发了。 现在问这么多的衣服,怎么烧事件最短。 解析: 二分答案咯。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <c

poj 3258 二分最小值最大

题意: 有一些石头排成一条线,第一个和最后一个不能去掉。 其余的共可以去掉m块,要使去掉后石头间距的最小值最大。 解析: 二分石头,最小值最大。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <c

poj 2594 二分图最大独立集

题意: 求一张图的最大独立集,这题不同的地方在于,间接相邻的点也可以有一条边,所以用floyd来把间接相邻的边也连起来。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <sta

poj 3692 二分图最大独立集

题意: 幼儿园里,有G个女生和B个男生。 他们中间有女生和女生认识,男生男生认识,也有男生和女生认识的。 现在要选出一些人,使得这里面的人都认识,问最多能选多少人。 解析: 反过来建边,将不认识的男生和女生相连,然后求一个二分图的最大独立集就行了。 下图很直观: 点击打开链接 原图: 现图: 、 代码: #pragma comment(

poj 2112 网络流+二分

题意: k台挤奶机,c头牛,每台挤奶机可以挤m头牛。 现在给出每只牛到挤奶机的距离矩阵,求最小化牛的最大路程。 解析: 最大值最小化,最小值最大化,用二分来做。 先求出两点之间的最短距离。 然后二分匹配牛到挤奶机的最大路程,匹配中的判断是在这个最大路程下,是否牛的数量达到c只。 如何求牛的数量呢,用网络流来做。 从源点到牛引一条容量为1的边,然后挤奶机到汇点引一条容量为m的边

数论ZOJ 2562

题意:给定一个数N,求小于等于N的所有数当中,约数最多的一个数,如果存在多个这样的数,输出其中最大的一个。 分析:反素数定义:对于任何正整数x,其约数的个数记做g(x).例如g(1)=1,g(6)=4.如果某个正整数x满足:对于任意i(0<i<x),都有g(i)<g(x),则称x为反素数。 性质一:一个反素数的质因子必然是从2开始连续的质数。 性质二:p=2^t1*3^t2*5^t3*7

二分最大匹配总结

HDU 2444  黑白染色 ,二分图判定 const int maxn = 208 ;vector<int> g[maxn] ;int n ;bool vis[maxn] ;int match[maxn] ;;int color[maxn] ;int setcolor(int u , int c){color[u] = c ;for(vector<int>::iter